function obj = pol_obj(TRcoefs)

global beta sig kappa altrho_re altrho_u altrho_mpi altrho_my ...
    sig_re sig_u sig_mpi sig_my alpha

PHIr = sig*(1-altrho_re)*(1-beta*altrho_re) - kappa*altrho_re;
PHIu = sig*(1-altrho_u)*(1-beta*altrho_u) - kappa*altrho_u;
PHImpi = sig*(1-altrho_mpi)*(1-beta*altrho_mpi) - kappa*altrho_mpi;
PHImy = sig*(1-altrho_my)*(1-beta*altrho_my) - kappa*altrho_my;

phiy    = TRcoefs(1);
phipi   = TRcoefs(2);

TERMre = 1/(PHIr + phiy*(1-beta*altrho_re) + kappa*phipi)^2*...
    (alpha*kappa^2+(1-beta*altrho_re)^2)*sig_re^2/(1-altrho_re^2);

TERMu = 1/(PHIu + phiy*(1-beta*altrho_u) + kappa*phipi)^2*...
    (alpha*(phiy + (1-altrho_u)*sig)^2+(altrho_u-phipi)^2)*sig_u^2/(1-altrho_u^2);

TERMmpi = 1/(PHImpi + phiy*(1-beta*altrho_mpi) + kappa*phipi)^2*...
    (alpha*kappa^2+(1-beta*altrho_mpi)^2)*phipi^2*sig_mpi^2/(1-altrho_mpi^2);

TERMmy = 1/(PHImy + phiy*(1-beta*altrho_my) + kappa*phipi)^2*...
    (alpha*kappa^2+(1-beta*altrho_my)^2)*phiy^2*sig_my^2/(1-altrho_my^2);

obj = TERMre + TERMu + TERMmpi + TERMmy;

end
